Index: COPYING
===================================================================
--- COPYING	(revision 81001c014737e692c2e32bdc550a8fa0ae2cd7e1)
+++ COPYING	(revision 81001c014737e692c2e32bdc550a8fa0ae2cd7e1)
@@ -0,0 +1,39 @@
+Copyright (c) 2006-2008 The BarnOwl Developers. All rights reserved.
+Copyright (c) 2004 James Kretchmar. All rights reserved.
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions are
+met:
+
+  * Redistributions of source code must retain the above copyright
+    notice, this list of conditions and the following disclaimer.
+
+  * Redistributions in binary form must reproduce the above copyright
+    notice, this list of conditions and the following disclaimer in
+    the documentation and/or other materials provided with the
+    distribution.
+
+  * Redistributions in any form must be accompanied by information on
+    how to obtain complete source code for the BarnOwl software and
+    any accompanying software that uses the BarnOwl software. The
+    source code must either be included in the distribution or be
+    available for no more than the cost of distribution plus a nominal
+    fee, and must be freely redistributable under reasonable
+    conditions. For an executable file, complete source code means the
+    source code for all modules it contains. It does not include
+    source code for modules or files that typically accompany the
+    major components of the operating system on which the executable
+    file runs.
+
+
+THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
+NON-INFRINGEMENT, ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE
+LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
+BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
+OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
+IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
Index: functions.c
===================================================================
--- functions.c	(revision 81655f8c44b634198f4f03d1fd96fbbd6f8a6717)
+++ functions.c	(revision 81001c014737e692c2e32bdc550a8fa0ae2cd7e1)
@@ -1467,14 +1467,11 @@
   strcat(buff, "because we feel our owls should live closer to our ponies.\n");
   strcat(buff, "\n");
+  strcat(buff, "Copyright (c) 2006-2008 The BarnOwl Developers. All rights reserved.\n");
+  strcat(buff, "Copyright (c) 2004 James Kretchmar. All rights reserved.\n");
   strcat(buff, "Copyright 2002 Massachusetts Institute of Technology\n");
   strcat(buff, "\n");
-  strcat(buff, "Permission to use, copy, modify, and distribute this\n");
-  strcat(buff, "software and its documentation for any purpose and without\n");
-  strcat(buff, "fee is hereby granted, provided that the above copyright\n");
-  strcat(buff, "notice and this permission notice appear in all copies\n");
-  strcat(buff, "and in supporting documentation.  No representation is\n");
-  strcat(buff, "made about the suitability of this software for any\n");
-  strcat(buff, "purpose.  It is provided \"as is\" without express\n");
-  strcat(buff, "or implied warranty.\n");
+  strcat(buff, "This program is free software. You can redistribute it and/or\n");
+  strcat(buff,  "modify under the terms of the Sleepycat License. Use the \n");
+  strcat(buff,  "':show license' command to display the full license\n");
   owl_function_popless_text(buff);
 }
Index: owl.c
===================================================================
--- owl.c	(revision 52f8dd6f954e971462a0a3fedc3550d1d0060e91)
+++ owl.c	(revision 81001c014737e692c2e32bdc550a8fa0ae2cd7e1)
@@ -1,39 +1,8 @@
-/*  Copyright (c) 2004 James Kretchmar. All rights reserved.
+/*  Copyright (c) 2006-2008 The BarnOwl Developers. All rights reserved.
+ *  Copyright (c) 2004 James Kretchmar. All rights reserved.
  *
- *  Redistribution and use in source and binary forms, with or without
- *  modification, are permitted provided that the following conditions are
- *  met:
- *  
- *    * Redistributions of source code must retain the above copyright
- *      notice, this list of conditions and the following disclaimer.
- *  
- *    * Redistributions in binary form must reproduce the above copyright
- *      notice, this list of conditions and the following disclaimer in
- *      the documentation and/or other materials provided with the
- *      distribution.
- *  
- *    * Redistributions in any form must be accompanied by information on
- *      how to obtain complete source code for the Owl software and any
- *      accompanying software that uses the Owl software. The source code
- *      must either be included in the distribution or be available for no
- *      more than the cost of distribution plus a nominal fee, and must be
- *      freely redistributable under reasonable conditions. For an
- *      executable file, complete source code means the source code for
- *      all modules it contains. It does not include source code for
- *      modules or files that typically accompany the major components of
- *      the operating system on which the executable file runs.
- *  
- * 
- *  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- *  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
- *  WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
- *  NON-INFRINGEMENT, ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE
- *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
- *  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
- *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
- *  OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
- *  IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *  This program is free software. You can redistribute it and/or
+ *  modify under the terms of the Sleepycat License. See the COPYING
+ *  file included with the distribution for more information.
  */
 
Index: owl.h
===================================================================
--- owl.h	(revision 50dd3a02cb8b3f00ba4c3a91d74bb36f3da6c3f1)
+++ owl.h	(revision 81001c014737e692c2e32bdc550a8fa0ae2cd7e1)
@@ -1,39 +1,8 @@
-/*  Copyright (c) 2004 James Kretchmar. All rights reserved.
+/*  Copyright (c) 2006-2008 The BarnOwl Developers. All rights reserved.
+ *  Copyright (c) 2004 James Kretchmar. All rights reserved.
  *
- *  Redistribution and use in source and binary forms, with or without
- *  modification, are permitted provided that the following conditions are
- *  met:
- *  
- *    * Redistributions of source code must retain the above copyright
- *      notice, this list of conditions and the following disclaimer.
- *  
- *    * Redistributions in binary form must reproduce the above copyright
- *      notice, this list of conditions and the following disclaimer in
- *      the documentation and/or other materials provided with the
- *      distribution.
- *  
- *    * Redistributions in any form must be accompanied by information on
- *      how to obtain complete source code for the Owl software and any
- *      accompanying software that uses the Owl software. The source code
- *      must either be included in the distribution or be available for no
- *      more than the cost of distribution plus a nominal fee, and must be
- *      freely redistributable under reasonable conditions. For an
- *      executable file, complete source code means the source code for
- *      all modules it contains. It does not include source code for
- *      modules or files that typically accompany the major components of
- *      the operating system on which the executable file runs.
- *  
- * 
- *  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- *  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
- *  WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
- *  NON-INFRINGEMENT, ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE
- *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
- *  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
- *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
- *  OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
- *  IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *  This program is free software. You can redistribute it and/or
+ *  modify under the terms of the Sleepycat License. See the COPYING
+ *  file included with the distribution for more information.
  */
 
@@ -86,7 +55,5 @@
 #endif
 
-#ifndef OWL_VERSION_STRING
 #define OWL_VERSION_STRING "r" BARNOWL_STRINGIFY(OWL_SVN_REVNO)
-#endif
 
 